Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/src/test.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/SelfTest/src/test.cpp	(revision 30)
@@ -9,4 +9,5 @@
 #define NB_ITERATION 16
 
+#define TEXT(str)  do {cout << "<" << name << "> : " << str << endl;} while (0)
 #define LABEL(str) do {cout << "{"+toString(static_cast<uint32_t>(sc_simulation_time()))+"} " << str << endl; _RegisterFile_Multi_Banked_Glue->vhdl_testbench_label(str);} while (0)
 
@@ -18,5 +19,5 @@
 	   morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::Parameters _param)
 {
-  cout << "<" << name << "> : Simulation SystemC" << endl;
+  TEXT("Simulation SystemC");
 
   RegisterFile_Multi_Banked_Glue * _RegisterFile_Multi_Banked_Glue = new RegisterFile_Multi_Banked_Glue (name.c_str(),
@@ -192,5 +193,5 @@
    ********************************************************/
   
-  cout << "<" << name << "> Instanciation of _RegisterFile_Multi_Banked_Glue" << endl;
+   TEXT("Instanciation of _RegisterFile_Multi_Banked_Glue");
   
   (*(_RegisterFile_Multi_Banked_Glue->in_CLOCK))        (*(CLOCK));
@@ -247,5 +248,5 @@
 
 
-  cout << "<" << name << "> Start Simulation ............" << endl;
+   TEXT("Start Simulation ............");
   
   /********************************************************
@@ -265,13 +266,13 @@
 
   uint32_t   read_in_num_bank [_param._nb_port_read]; // Number of bank
-//Tcontrol_t read_in_valid    [_param._nb_port_read];
+  Tcontrol_t read_is_busy     [_param._nb_port_read];
+  bool       read_out_find    [_param._nb_bank][_param._nb_port_read_by_bank];  
+  uint32_t   read_out_port    [_param._nb_bank][_param._nb_port_read_by_bank];  
+
   Tcontrol_t read_in_ack      [_param._nb_port_read]; // to test
   Tdata_t    read_in_data     [_param._nb_port_read]; // to test
   Tcontrol_t read_out_val     [_param._nb_bank][_param._nb_port_read_by_bank];  
-  Tcontrol_t read_out_ack     [_param._nb_bank][_param._nb_port_read_by_bank];  
   Taddress_t read_out_address [_param._nb_bank][_param._nb_port_read_by_bank];  
-  Tcontrol_t read_is_busy     [_param._nb_port_read];
-  Tcontrol_t read_select_val  [_param._nb_bank][_param._nb_port_read        ];
-  Tcontrol_t read_select_ack  [_param._nb_bank][_param._nb_port_read        ];
+  Tcontrol_t read_select_val  [_param._nb_bank][_param._nb_port_read_by_bank][_param._nb_port_read];
 
   LABEL("Loop of Test");
@@ -281,5 +282,5 @@
       LABEL("Iteration "+toString(iteration));
       
-      LABEL("Test read_in");
+      //LABEL("Test read_in");
       
       // Write in interface "read_in"
@@ -287,34 +288,32 @@
 	{
 	  read_in_num_bank  [i] =  rand() % _param._nb_bank;
-	  Tcontrol_t read_in_valid = (rand() % 2) != 0;
+	  Tcontrol_t read_in_val = (rand() % 2) != 0;
 
 	  Taddress_t address    = (read_in_num_bank[i] << _param._shift_address) | (gen_mask<Taddress_t>(_param._size_address-_param._shift_address) & i);
 
-	  read_is_busy      [i] = (read_in_valid == 0);
-	  read_in_ack       [i] = 0;
-	  read_in_data      [i] = 0;
-	  READ_IN_VAL       [i]->write(read_in_valid);
-	  READ_IN_ADDRESS   [i]->write(address);
-
-	  for (uint32_t j=0; j<_param._nb_bank; j++)
-	    read_select_ack [j][i] = 0;
+	  read_is_busy      [i] = (read_in_val == 0);   // invalid = busy
+	  read_in_ack       [i] = 0;                    // init
+	  read_in_data      [i] = 0;                    // init
+	  READ_IN_VAL       [i]->write(read_in_val);    // write signal
+	  READ_IN_ADDRESS   [i]->write(address);        // write signal
 	}
 
-      for (uint32_t i=0; i<_param._nb_bank; i++)
-	for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
-	  {
-	    read_out_ack      [i][j] = (rand() % 2) != 0;
-	    READ_OUT_ACK      [i][j]->write(read_out_ack      [i][j]);
-	    READ_OUT_DATA     [i][j]->write((j<<1)|1); // (j<<1)|1 afin de n'avoir jamais 0
-	  }
-      
       // compute the good read_select
       for (uint32_t i=0; i<_param._nb_bank; i++)
 	for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
 	  {
+	    Tcontrol_t read_out_ack = (rand() % 2) != 0;
+	    READ_OUT_ACK     [i][j]->write(read_out_ack);
+	    READ_OUT_DATA    [i][j]->write((j<<1)|1);            // (j<<1)|1 afin de n'avoir jamais 0
+
+	    read_out_find    [i][j] = false;
+	    read_out_port    [i][j] = 0;
+
+	    read_out_val     [i][j] = 0;
+	    read_out_address [i][j] = 0;
+
 	    bool find = false; // have find a port_in to link with this port_out
 	    for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port[j]; k++)
 	      {
-
 		uint32_t num_port; // number of port
 		
@@ -323,27 +322,31 @@
 		  num_port = k;
 		else
-		  num_port = _param._link_port_read [i];
-
-		read_select_val [i][num_port] = read_out_ack [i][j] && not read_is_busy [num_port];
-		
-		if ((read_out_ack [i][j] == 0) || find)
-		  read_select_ack [i][num_port] = 0; // read_out is busy or already find
-		else
+		  num_port = k*_param._nb_port_read_by_bank+j;
+
+		read_select_val [i][j][k] = read_out_ack and not read_is_busy [num_port] and (read_in_num_bank[num_port] == i); // select val if port is not busy and out accept a data
+		Tcontrol_t read_select_ack = 0;
+
+		// test a previous find
+		if (not ((read_out_ack == 0) || find))
 		  {
 		    // find a busy port?
-		    find = not read_is_busy [num_port];
-		    read_is_busy       [num_port]|= find;
-		    read_select_ack [i][num_port] = find;
+		    find                      = read_select_val;
+		    read_is_busy   [num_port]|= find; // port became busy if find
+		    read_select_ack           = find; // ack if find
 
 		    if (find)
 		      {
+			read_out_find    [i][j] = true;
+			read_out_port    [i][j] = num_port;
+
+			// know the good output
 			read_in_ack      [num_port] = 1;
 			read_in_data     [num_port] = ((j<<1)|1);
 			read_out_val     [i][j]     = 1;
-			read_out_address [i][j]     = (read_in_num_bank[i] << _param._shift_address) | (gen_mask<Taddress_t>(_param._size_address-_param._shift_address) & i);
+			read_out_address [i][j]     = (i << _param._shift_address) | (gen_mask<Taddress_t>(_param._size_address-_param._shift_address) & num_port);
 		      }
 		  }
 		
-		READ_SELECT_ACK [i][j][k]->write(read_select_ack [i][num_port]);
+		READ_SELECT_ACK [i][j][k]->write(read_select_ack);
 	      }
 	  }
@@ -352,14 +355,65 @@
       sc_start(1);
 
-//       // lot of test
-//   public    : SC_OUT(Tcontrol_t)           ** out_READ_IN_ACK       ;
-//   public    : SC_OUT(Tdata_t   )           ** out_READ_IN_DATA      ;
-
-//   public    : SC_OUT(Tcontrol_t)         **** out_READ_SELECT_VAL   ;
-
-//   public    : SC_OUT(Tcontrol_t)          *** out_READ_OUT_VAL      ;
-//   public    : SC_OUT(Taddress_t)          *** out_READ_OUT_ADDRESS  ;
+      // test output
+
+      TEXT ("===== Test Output =====");
+      for (uint32_t i=0; i<_param._nb_port_read; i++)
+	{
+	  TEXT ("Read_in         [" << i << "]       : "
+		<< READ_IN_VAL [i]->read() << ","
+		<< read_in_ack [i]         << " - "
+		<< "Reg[" << READ_IN_ADDRESS [i]->read() << "] -> "
+		<< read_in_data [i] << " "
+		<< "{bank : " << read_in_num_bank[i] << "}"
+		);
+
+	  TEST (Tcontrol_t, read_in_ack  [i], READ_IN_ACK  [i]->read());
+	  if (READ_IN_VAL [i]->read() and READ_IN_ACK [i]->read())
+	  TEST (Tdata_t   , read_in_data [i], READ_IN_DATA [i]->read());
+	}
+
+      cout << endl;
+      for (uint32_t i=0; i<_param._nb_bank; i++)
+	for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
+	  {
+	    TEXT ("Read_out        [" << i << "][" << j << "]    : "
+		  << read_out_val [i][j]         << ","
+		  << READ_OUT_ACK [i][j]->read() << " - "
+		  << "Reg[" << read_out_address [i][j] << "] -> "
+		  << READ_OUT_DATA [i][j]->read() << " - "
+		  << "[" << read_out_find [i][j]<< " , "
+		  << read_out_port    [i][j] << "]"		  
+		  );
+
+	    TEST (Tcontrol_t, read_out_val     [i][j], READ_OUT_VAL     [i][j]->read());
+	    if (READ_OUT_VAL [i][j]->read() and READ_OUT_ACK [i][j]->read())
+	    TEST (Taddress_t, read_out_address [i][j], READ_OUT_ADDRESS [i][j]->read());
+
+	    for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port[j]; k++)
+	      {
+		uint32_t num_port; // number of port
+		
+		// compute the good number of port
+		if (_param._crossbar == FULL_CROSSBAR)
+		  num_port = k;
+		else
+		  num_port = k*_param._nb_port_read_by_bank+j;
+		
+		TEXT (" * Read_select  [" << i << "][" << j << "][" << k << "] : "
+		      << read_select_val [i][j][k]         << ","
+		      << READ_SELECT_ACK [i][j][k]->read() << " - "
+		      << "link with read_in[" << num_port << "]"
+		      );
+		
+		TEST (Tcontrol_t, read_select_val  [i][j][k], READ_SELECT_VAL  [i][j][k]->read());
+	      }
+	    
+	    
+	    
+	  }
 
     }
+
+  sc_start(0);
 
   /********************************************************
@@ -367,14 +421,20 @@
    ********************************************************/
 
-  cout << "<" << name << "> ............ Stop Simulation" << endl;
+  TEXT("............ Stop Simulation");
 
   delete CLOCK;
 
+  TEXT("delete read_in");
   for (uint32_t i=0; i<_param._nb_port_read; i++)
     {
+//       TEXT("1, i " << i);
       delete READ_IN_VAL       [i];
+//       TEXT("2");
       delete READ_IN_ACK       [i];
+//       TEXT("3");
       delete READ_IN_ADDRESS   [i];
+//       TEXT("4");
       delete READ_IN_DATA      [i];
+//       TEXT("5");
     }
   						      
@@ -384,4 +444,5 @@
   delete READ_IN_DATA   ;
 
+  TEXT("delete read_select");
    for (uint32_t i=0; i<_param._nb_bank; i++)
      {
@@ -402,4 +463,5 @@
    delete READ_SELECT_ACK;
 
+  TEXT("delete read_out");
    for (uint32_t i=0; i<_param._nb_bank; i++)
      {
@@ -423,4 +485,5 @@
   delete READ_OUT_DATA   ;
 
+  TEXT("delete write_in");
   for (uint32_t i=0; i<_param._nb_port_write; i++)
     {
@@ -436,4 +499,5 @@
   delete WRITE_IN_DATA   ;
 
+  TEXT("delete write_select");
   for (uint32_t i=0; i<_param._nb_bank; i++)
     {
@@ -454,4 +518,5 @@
   delete WRITE_SELECT_ACK;
   
+  TEXT("delete write_out");
   for (uint32_t i=0; i<_param._nb_bank; i++)
     {
@@ -477,4 +542,5 @@
 #endif
 
+
   delete _RegisterFile_Multi_Banked_Glue;
 }
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/doc/Makefile	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/doc/Makefile	(revision 30)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/Parameters.h	(revision 30)
@@ -63,9 +63,9 @@
   public : const uint32_t    _shift_address        ;
 
-  public :       uint32_t  * _link_port_read       ; 
-  public :       uint32_t  * _link_port_write      ;
-
-  public :       uint32_t  * _nb_port_select_by_bank_read_port ;
-  public :       uint32_t  * _nb_port_select_by_bank_write_port;
+    // A lot of table to the partial crossbar
+  public :       uint32_t  * _link_port_read_in_to_out    ;
+  public :       uint32_t  * _link_port_read_in_to_select ;
+  public :       uint32_t  * _link_port_write_in_to_out   ;
+  public :       uint32_t  * _link_port_write_in_to_select;
 
     //-----[ methods ]-----------------------------------------------------------
@@ -82,5 +82,5 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
+  public : string msg_error           (void);
 
   public :        string   print      (uint32_t depth);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h	(revision 30)
@@ -119,4 +119,19 @@
 					       
 #ifdef SYSTEMC				       
+    // function pointer
+  public : uint32_t  (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::*link_port_read_in_to_out    ) (uint32_t, uint32_t);
+  public : uint32_t  (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::*link_port_read_in_to_select ) (uint32_t, uint32_t);
+  public : uint32_t  (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::*link_port_write_in_to_out   ) (uint32_t, uint32_t);
+  public : uint32_t  (morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::*link_port_write_in_to_select) (uint32_t, uint32_t);
+
+  public : uint32_t  full_crossbar_link_port_read_in_to_out        (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  full_crossbar_link_port_read_in_to_select     (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  full_crossbar_link_port_write_in_to_out       (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  full_crossbar_link_port_write_in_to_select    (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  partial_crossbar_link_port_read_in_to_out     (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  partial_crossbar_link_port_read_in_to_select  (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  partial_crossbar_link_port_write_in_to_out    (uint32_t num_port, uint32_t num_bank);
+  public : uint32_t  partial_crossbar_link_port_write_in_to_select (uint32_t num_port, uint32_t num_bank);
+
   private : void     allocation                (void);
   private : void     deallocation              (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/Parameters.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/Parameters.cpp	(revision 30)
@@ -31,5 +31,5 @@
     _nb_port_write_by_bank (nb_port_write_by_bank),
     _crossbar              (crossbar             ),
-    _shift_address         (static_cast<uint32_t>(ceil(log2(_nb_bank))))
+    _shift_address         (_size_address-static_cast<uint32_t>(ceil(log2(_nb_bank))))
   {
     log_printf(FUNC,RegisterFile_Multi_Banked_Glue,"Parameters","Begin");
@@ -39,46 +39,37 @@
 	// All port_src is connected with one port_dest on each bank
 	
-	_link_port_read  = new uint32_t [_nb_port_read ];
-	for (uint32_t i=0; i<_nb_port_read ; i++)
-	  _link_port_read  [i] = i%_nb_port_read_by_bank;
+	_link_port_read_in_to_out          = new uint32_t [_nb_port_read ];
+	_link_port_read_in_to_select       = new uint32_t [_nb_port_read ];
+	_link_port_write_in_to_out         = new uint32_t [_nb_port_write];
+	_link_port_write_in_to_select      = new uint32_t [_nb_port_write];
+	uint32_t _nb_port_select_by_bank_read_port  [_nb_port_read_by_bank ];
+	uint32_t _nb_port_select_by_bank_write_port [_nb_port_write_by_bank];
+	
+	// init
+	for (uint32_t i=0; i<_nb_port_read_by_bank ;i++)
+	  _nb_port_select_by_bank_read_port  [i] = 0;
+	
+	for (uint32_t i=0; i<_nb_port_read         ;i++)
+	  {
+	    uint32_t x = i%_nb_port_read_by_bank;
+	    _link_port_read_in_to_out          [i] = x;
+	    _link_port_read_in_to_select       [i] = _nb_port_select_by_bank_read_port [x];
+	    _nb_port_select_by_bank_read_port  [x] ++;
+	  }
 
-	_link_port_write = new uint32_t [_nb_port_write];
-	for (uint32_t i=0; i<_nb_port_write; i++)
-	  _link_port_write [i] = i%_nb_port_write_by_bank;
+	// init
+	for (uint32_t i=0; i<_nb_port_write_by_bank ;i++)
+	  _nb_port_select_by_bank_write_port [i] = 0;
+	
+	for (uint32_t i=0; i<_nb_port_write         ;i++)
+	  {
+	    uint32_t x = i%_nb_port_write_by_bank;
+	    _link_port_write_in_to_out         [i] = x;
+	    _link_port_write_in_to_select      [i] = _nb_port_select_by_bank_write_port [x];
+	    _nb_port_select_by_bank_write_port [x] ++;
+	  }
       }
     // else : don't allocate
 
-    _nb_port_select_by_bank_read_port  = new uint32_t [_nb_port_read_by_bank ];
-    
-    if (_crossbar == FULL_CROSSBAR)
-      // All port_src is connected with all port_dest on each bank
-      for (uint32_t i=0; i<_nb_port_read_by_bank ;i++)
-	_nb_port_select_by_bank_read_port [i] = _nb_port_read;
-    else
-      // All port_src is connected with one port_dest on each bank
-      {
-	for (uint32_t i=0; i<_nb_port_read_by_bank ;i++)
-	  _nb_port_select_by_bank_read_port [i] = 0;
-
-	for (uint32_t i=0; i<_nb_port_read         ;i++)
-	  _nb_port_select_by_bank_read_port [_link_port_read [i]] ++;
-      }
-    
-    _nb_port_select_by_bank_write_port = new uint32_t [_nb_port_write_by_bank];
-
-    if (_crossbar == FULL_CROSSBAR)
-      // All port_src is connected with all port_dest on each bank
-      for (uint32_t i=0; i<_nb_port_write_by_bank ;i++)
-	_nb_port_select_by_bank_write_port [i] = _nb_port_write;
-    else
-      // All port_src is connected with one port_dest on each bank
-      {
-	for (uint32_t i=0; i<_nb_port_write_by_bank ;i++)
-	  _nb_port_select_by_bank_write_port [i] = 0;
-
-	for (uint32_t i=0; i<_nb_port_write         ;i++)
-	  _nb_port_select_by_bank_write_port [_link_port_write[i]] ++;
-      }
-    
     test();
     log_printf(FUNC,RegisterFile_Multi_Banked_Glue,"Parameters","End");
@@ -97,13 +88,4 @@
    {
     log_printf(FUNC,RegisterFile_Multi_Banked_Glue,"Parameters (copy)","Begin");
-
-    _nb_port_select_by_bank_read_port  = new uint32_t [_nb_port_read_by_bank ];
-    for (uint32_t i=0; i<_nb_port_read_by_bank; i++)
-      _nb_port_select_by_bank_read_port [i] = param._nb_port_select_by_bank_read_port [i];
-    
-    _nb_port_select_by_bank_write_port = new uint32_t [_nb_port_write_by_bank ];
-    for (uint32_t i=0; i<_nb_port_write_by_bank; i++)
-      _nb_port_select_by_bank_write_port[i] = param._nb_port_select_by_bank_write_port [i];
-    
     test();
     log_printf(FUNC,RegisterFile_Multi_Banked_Glue,"Parameters (copy)","End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/RegisterFile_Multi_Banked_Glue.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/RegisterFile_Multi_Banked_Glue.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/RegisterFile_Multi_Banked_Glue.cpp	(revision 30)
@@ -33,4 +33,22 @@
     log_printf(FUNC,RegisterFile_Multi_Banked_Glue,"RegisterFile_Multi_Banked_Glue","Begin");
 
+#ifdef SYSTEMC
+    // write function pointer
+    if (_crossbar == PARTIAL_CROSSBAR)
+      {
+	link_port_read_in_to_out     = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::partial_crossbar_link_port_read_in_to_out    ;
+ 	link_port_read_in_to_select  = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::partial_crossbar_link_port_read_in_to_select ;
+ 	link_port_write_in_to_out    = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::partial_crossbar_link_port_write_in_to_out   ;
+ 	link_port_write_in_to_select = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::partial_crossbar_link_port_write_in_to_select;
+      }
+    else
+      {
+ 	link_port_read_in_to_out     = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::   full_crossbar_link_port_read_in_to_out    ;
+ 	link_port_read_in_to_select  = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::   full_crossbar_link_port_read_in_to_select ;
+ 	link_port_write_in_to_out    = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::   full_crossbar_link_port_write_in_to_out   ;
+ 	link_port_write_in_to_select = &morpheo::behavioural::generic::registerfile::registerfile_multi_banked::registerfile_multi_banked_glue::RegisterFile_Multi_Banked_Glue::   full_crossbar_link_port_write_in_to_select;
+      }
+#endif
+
 #ifdef STATISTICS
     log_printf(INFO,RegisterFile_Multi_Banked_Glue,"RegisterFile_Multi_Banked_Glue","Allocation of statistics");
@@ -66,5 +84,5 @@
 
     allocation ();
-
+    
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
     log_printf(INFO,RegisterFile_Multi_Banked_Glue,"RegisterFile_Multi_Banked_Glue","Method - transition");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/RegisterFile_Multi_Banked_Glue_genMealy_read_in.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/RegisterFile_Multi_Banked_Glue_genMealy_read_in.cpp	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/src/RegisterFile_Multi_Banked_Glue_genMealy_read_in.cpp	(revision 30)
@@ -9,5 +9,5 @@
 #include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/RegisterFile_Multi_Banked_Glue/include/RegisterFile_Multi_Banked_Glue.h"
 
-namespace morpheo                    {
+namespace morpheo {
 namespace behavioural {
 namespace generic {
@@ -16,27 +16,41 @@
 namespace registerfile_multi_banked_glue {
 
-  
   void RegisterFile_Multi_Banked_Glue::genMealy_read_in (void)
   {
     log_printf(FUNC,RegisterFile_Multi_Banked_Glue,"genMealy_read_in","Begin");
     
-    for (uint32_t l=0; l<_param._nb_port_read; l++)
+    for (uint32_t i=0; i<_param._nb_port_read; i++)
       {
-	uint32_t num_bank = PORT_READ(in_READ_IN_ADDRESS [l])>>_param._shift_address;
+	log_printf(ALL,RegisterFile_Multi_Banked_Glue,"genMealy_read_in","read_in [%d]",i);
 
+	uint32_t num_bank        = PORT_READ(in_READ_IN_ADDRESS [i])>>_param._shift_address;
+	uint32_t num_port_out    = *link_port_read_in_to_out    (i,num_bank);
+	uint32_t num_port_select = *link_port_read_in_to_select (i,num_bank);
+
+	if (_param._crossbar == FULL_CROSSBAR) 
+	  {
+	    // scearch in all possible destination the good
+	    // if not found : num_port = 0
+	    for (num_port = _param._nb_port_read_by_bank-1; num_port > 0; num_port --)
+	      {
+		log_printf(ALL,RegisterFile_Multi_Banked_Glue,"genMealy_read_in","test read_out_port   %d",num_port);		
+		
+		for (uint32_t j=0; j<_param._nb_port_select_by_bank_read_port [num_port]; j++)
+		  {
+                log_printf(ALL,RegisterFile_Multi_Banked_Glue,"genMealy_read_in","test read_out_select %d",j);
+		    if (PORT_READ(in_READ_SELECT_ACK [num_bank][num_port][j])==1)
+		      goto end_FULL_CROSSBAR;
+		  }
+	      }
+	  }
+	
+	end_FULL_CROSSBAR :	
+	  
+	log_printf(TRACE,RegisterFile_Multi_Banked_Glue,"genMealy_read_in","read_in [%d] address : %.8x - num_bank %d, num_port %d",i,static_cast<uint32_t>(PORT_READ(in_READ_IN_ADDRESS [i])),num_bank,num_port);
+	
+	PORT_WRITE(out_READ_IN_ACK  [i],PORT_READ(in_READ_SELECT_ACK [num_bank][num_port]));
+	PORT_WRITE(out_READ_IN_DATA [i],PORT_READ(in_READ_OUT_DATA   [num_bank][num_port]));
 // 	(*(out_READ_IN_ACK  [l])) (*(in_READ_IN_ADDRESS [i][j]));
 // 	(*(out_READ_IN_DATA [l])) (*(in_READ_IN_ADDRESS [i][j]));
-
-// 	for (uint32_t i=0; i<_param._nb_bank; i++)
-// 	  for (uint32_t j=0; j<_param._nb_port_read_by_bank; j++)
-// 	    {
-// 	      (*(out_READ_IN_ACK  [l])) (*(in_READ_OUT_ACK      [i][j]));
-// 	      (*(out_READ_IN_DATA [l])) (*(in_READ_OUT_DATA     [i][j]));
-// 	      for (uint32_t k=0; k<_param._nb_port_select_by_bank_read_port[j]; k++)
-// 		{
-// 		  (*(out_READ_IN_ACK  [l])) (*(in_READ_SELECT_ACK [i][j][k]));
-// 		  (*(out_READ_IN_DATA [l])) (*(in_READ_SELECT_ACK [i][j][k]));
-// 		}
-// 	    }
       }
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/Makefile	(revision 30)
@@ -24,5 +24,5 @@
 
 include                         ../Makefile.deps
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/doc/Makefile	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/doc/Makefile	(revision 30)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/Makefile	(revision 30)
@@ -8,5 +8,6 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_MORPHEO			= ../../../..
+DIR_COMPONENT			= .
+include				$(DIR_COMPONENT)/Makefile.defs
 
 #-----[ Library ]------------------------------------------
@@ -19,5 +20,5 @@
 				@$(MAKE) all_component
 
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/Makefile.defs	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/Makefile.defs	(revision 30)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/Makefile	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/Makefile	(revision 30)
@@ -24,5 +24,5 @@
 
 include                         ../Makefile.deps
-include                         $(DIR_MORPHEO)/Behavioural/Makefile.defs
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
 include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/configuration.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/configuration.cfg	(revision 20)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/configuration.cfg	(revision 30)
@@ -1,4 +1,4 @@
 Select_Priority_Fixed
-2	16	*2	# nb_entity
-0	1	+1	# encoding_one_hot
+16	16	*2	# nb_entity
+0	0	+1	# encoding_one_hot
 1	1	+1	# encoding_compact
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/doc/Makefile	(revision 30)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/doc/Makefile	(revision 30)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
